//////////////////////////////////////////////////////////
// User Interface
// 
// (c) 2009 by Claus N.
//////////////////////////////////////////////////////////
PANEL* HealthBarPan =
{
	layer = 1;
	bmap = HealthBarBG;
	window(12,12,376,26,HealthbarMap,UIVAR_PlayerHealth,null);
}
//////////////////////////////////////////////////////////
PANEL* HealthBarTargetPan =
{
	layer = 1;
	bmap = HealthBarBG;
	window(12,12,376,26,HealthbarTargetMap,UIVAR_TargetHealth,null);
}
//////////////////////////////////////////////////////////
TEXT* PlayerTargetText =
{
	layer = 1;
	font = PlayerTargetFont;
	string = PlayerTargetString;
}
//////////////////////////////////////////////////////////
TEXT* CombatHelpText =
{
	red = 255;
	green = 128;
	blue = 0;
	layer = 1;
	font = PlayerTargetFont;
	string = CombatHelpString;
	flags |= (CENTER_X | OUTLINE);
}
//////////////////////////////////////////////////////////
void ReadjustPanels()
{
	HealthBarPan.pos_x = 5;
	HealthBarPan.pos_y = screen_size.y - bmap_height(HealthBarPan.bmap) - 5;
	
	HealthBarTargetPan.pos_x = screen_size.x - bmap_width(HealthBarTargetPan.bmap) - 5;
	HealthBarTargetPan.pos_y = screen_size.y - bmap_height(HealthBarTargetPan.bmap) - 5;
	PlayerTargetText.pos_x = HealthBarTargetPan.pos_x + 5;
	PlayerTargetText.pos_y = HealthBarTargetPan.pos_y - 30;
	
	CombatHelpText.pos_x = screen_size.x / 2;
	CombatHelpText.pos_y = screen_size.y / 4;
}
//////////////////////////////////////////////////////////
void ToggleTargetUI()
{
	if(PlayerTarget != null)
	{
		ReadjustPanels();
		
		HealthBarTargetPan.flags |= SHOW;
		PlayerTargetText.flags |= SHOW;
	}
	else
	{
		HealthBarTargetPan.flags &= ~SHOW;
		PlayerTargetText.flags &= ~SHOW;
	}
}
//////////////////////////////////////////////////////////
void ShowUI()
{
	ReadjustPanels();
	
	HealthBarPan.flags |= SHOW;
	CombatHelpText.flags |= SHOW;
}
//////////////////////////////////////////////////////////
void SetCombatText(STRING* combatStr)
{
	str_cpy((CombatHelpText.pstring)[0],combatStr);
	
	wait(1);
	proc_kill(4);
	
	wait(-1);
	str_cpy((CombatHelpText.pstring)[0],"");
}
//////////////////////////////////////////////////////////
void FloatingCombatText(STRING* _combatStr,VECTOR* color,VECTOR* _position)
{
	VECTOR* position = vector(_position.x,_position.y,_position.z);
	position = vec_to_screen(position,camera);
	
	if(position == null) {return;}
	
	position.x += random(70) - random(70);
	position.y += random(50) - random(50);
	
	var i = 15;
	while(i > 0)
	{
		draw_text(_combatStr,position.x,position.y,color);
		
		position.y -= 5 * time_step;
		
		i -= 1 * time_step;
		
		wait(1);
	}
}
//////////////////////////////////////////////////////////
