//////////////////////////////////////////////////////////
// Basic Melee AI Script
// 
// (c) 2009 by Claus N.
//////////////////////////////////////////////////////////
void basicAI_Event()
{
	if(event_type == EVENT_CLICK)
	{
		PlayerTarget = me;
	}
	else if(event_type == EVENT_TOUCH)
	{
		MouseType = MOUSE_ATTACK;
		
		my.flags |= isMouseOver;
	}
	else if(event_type == EVENT_RELEASE)
	{
		MouseType = MOUSE_NORMAL;
		
		my.flags &= ~isMouseOver;
	}
}
//////////////////////////////////////////////////////////
action BasicAI()
{
	my.emask |= (ENABLE_CLICK | ENABLE_TOUCH | ENABLE_RELEASE);
	my.event = basicAI_Event;
	
	STRING* CombatString = "#32";
	
	if(my.movementSpeed == 0) {my.movementSpeed = 10;}
	if(my.range == 0) {my.range = 200;}
	if(my.evadeRange == 0) {my.evadeRange = my.range * 5;}
	if(my.meleeRange == 0) {my.meleeRange = 80;}
	if(my.max_health == 0) {my.max_health = 100;}
	if(my.health == 0) {my.health = my.max_health;}
	if(my.damage == 0) {my.damage = 15;}
	if(my.cooldown == 0) {my.cooldown = 10;}
	
	if(my.ANIM_SPEED_STAND == 0) {my.ANIM_SPEED_STAND = 1;}
	if(my.ANIM_SPEED_WALK == 0) {my.ANIM_SPEED_WALK = 12;}
	if(my.ANIM_SPEED_RUN == 0) {my.ANIM_SPEED_RUN = 25;}
	if(my.ANIM_SPEED_ATTACK == 0) {my.ANIM_SPEED_ATTACK = 20;}
	if(my.ANIM_SPEED_DEATH == 0) {my.ANIM_SPEED_DEATH = 25;}
	
	my.ACTOR_STATE = STATE_NULL;
	
	vec_set(my.spawn_x,my.x);
	
	while(my.health > 0)
	{
		cameraAlphaFade();
		attach_to_ground();
		animate_me();
		WaterlevelTrail();
		TargetableEntity();
		
		my.spawn_z = my.z;
		
		if((my.ACTOR_STATE & STATE_SPECIAL) == 0)
		{
			my.ACTOR_COOLDOWN = maxv(my.ACTOR_COOLDOWN - 1 * time_step,0);
			
			if(vec_dist(my.x,my.spawn_x) > my.evadeRange || my.ACTOR_STATE == STATE_EVADE)
			{
				my.ACTOR_STATE = STATE_EVADE;
				
				vec_set(my.target_x,my.spawn_x);
				
				if(vec_dist(my.x,my.spawn_x) < 50)
				{
					my.ACTOR_STATE = STATE_STAND;
				}
			}
			else if(player != null && player.ACTOR_STATE != STATE_DEAD && vec_dist(my.x,player.x) < my.range)
			{
				my.ACTOR_STATE = STATE_CHASE;
				
				if(vec_dist(my.x,player.x) < my.meleeRange)
				{
					if(my.ACTOR_COOLDOWN <= 0)
					{
						vec_set(my.target_x,nullvector);
						
						my.ACTOR_STATE = STATE_ATTACK;
						my.ACTOR_COOLDOWN = my.cooldown;
						
						my.skill48 = 0;
					}
					else
					{
						my.ACTOR_STATE = STATE_STAND;
					}
				}
				else
				{
					vec_set(my.target_x,player.x);
				}
			}
			else
			{
				if(vec_dist(my.x,my.target_x) < 40)
				{
					vec_set(my.target_x,nullvector);
				}
				else if(random(100) > 99 && my.ACTOR_STATE == STATE_STAND)
				{
					my.target_z = random(360);
					my.target_x = my.spawn_x + fcos(my.target_z,my.range*2);
					my.target_y = my.spawn_y + fsin(my.target_z,my.range*2);
					my.target_z = my.z;
					
					my.ACTOR_STATE = STATE_WALK;
				}
				
				if(vec_dist(my.target_x,nullvector) < 5)
				{
					my.ACTOR_STATE = STATE_STAND;
				}
			}
		}
		else if(my.ACTOR_STATE == STATE_ATTACK)
		{
			if(player != null && player.ACTOR_STATE != STATE_DEAD)
			{
				my.skill48 += my.ANIM_SPEED_ATTACK * time_step;
				
				if(my.skill48 > 95)
				{
					if(PlayerTarget == null) {PlayerTarget = me;}
					
					if(random(100) > 20)
					{
						player.health -= my.damage;
						
						str_for_num(CombatString,my.damage);
						FloatingCombatText(CombatString,FloatingTextColorEnemy,player.x);
						
						if(random(100) > 90 || player.ACTOR_STATE == STATE_REGENERATING)
						{
							player.ACTOR_STATE = STATE_STUNNED;
							player.skill48 = 0;
							
							FloatingCombatText(CombatStun,FloatingTextColorEnemy,player.x);
						}
					}
					else
					{
						FloatingCombatText(CombatMiss,FloatingTextColorEnemy,player.x);
					}
					
					my.ACTOR_STATE = STATE_STAND;
				}
				else
				{
					ent_animate(my,ANIM_ATTACK,my.skill48,null);
				}
			}
			else
			{
				my.ACTOR_STATE = STATE_EVADE;
			}
		}
		
		if(vec_dist(my.target_x,nullvector) > 5 && vec_dist(my.target_x,my.x) > abs(my.z - my.target_z) + 10)
		{
			vec_set(target,my.target_x);
			vec_sub(target,my.x);
			vec_to_angle(my.pan,target);
			
			my.tilt = 0;
			
			if((my.ACTOR_STATE & STATE_RUN) != 0)
			{
				my.speed_x = my.movementSpeed * time_step;
			}
			else
			{
				my.speed_x = my.movementSpeed * movementSpeedWalkFactor * time_step;
			}
			
			c_move(my,my.speed_x,nullvector,IGNORE_PASSABLE + GLIDE);
		}
		else
		{
			vec_set(my.target_x,nullvector);
		}
		
		wait(1);
	}
	
	my.ACTOR_STATE = STATE_DEAD;
	
	my.skill48 = 0;
	
	while(my.skill48 < 100)
	{
		TargetableEntity();
		ent_animate(my,"death",my.skill48,null);
		my.skill48 += my.ANIM_SPEED_DEATH * time_step;
		
		wait(1);
	}
	
	ent_animate(my,"death",100,null);
	
	FloatingCombatText(CombatDead,FloatingTextColorEnemy,my.x);
	
	while(my) {TargetableEntity();wait(1);}
}
//////////////////////////////////////////////////////////
void TargetableEntity()
{
	if((my.flags & isMouseOver) || PlayerTarget == me)
	{
		my.ambient = 100;
	}
	else
	{
		my.ambient = 0;
	}
	
	if(PlayerTarget == me)
	{
		if(my.TargetString == 0)
		{
			str_cpy((PlayerTargetText.pstring)[0],DefEnemyString);
		}
		else
		{
			str_cpy((PlayerTargetText.pstring)[0],ptr_for_handle(my.TargetString));
		}
		
		ToggleTargetUI();
		
		UIVAR_TargetHealth = clamp(my.health / my.max_health * 376,0,376);
	}
}
//////////////////////////////////////////////////////////
action SpiderAI()
{
	vec_scale(my.scale_x,1.6);
	
	my.TargetString = handle(EnemyStringSpider);
	
	my.damage = 3;
	my.max_health = 60;
	my.cooldown = 5;
	
	BasicAI();
}
//////////////////////////////////////////////////////////
action SpiderAI2()
{
	vec_scale(my.scale_x,3);
	
	my.skin = 2;
	
	my.TargetString = handle(EnemyStringSpider2);
	
	my.movementSpeed = 14;
	my.damage = 7;
	my.max_health = 150;
	my.cooldown = 15;
	
	my.ANIM_SPEED_WALK = 8;
	
	BasicAI();
}
//////////////////////////////////////////////////////////
